    
    %Tm ohjelma laskee erilaisten 65-vuotiaana ostettavien
    %hoivavakuutusten aktuaarisesti reilun hinnan.
    %Ohjelma liittyy lukuun 3 julkaisussa Valkonen, Tarmo (toim.): Hoivariskit, hoivavakuutusten hinta ja
    %vakuutustarve, ETLA B253, 2012. 
    %Laskelmat hydyntvt siirtymtodennkisyyksi, jotka on kuvattu luvussa 2. 
        
    %Ohjelman avulla voi mm. laskea ko. julkaisun taulukon 3.2 kolmen ensimmisen rivin
    %tulokset. Ohjelma laskee vakuutuskorvauksen keskimrisen nykyarvon 20 000
    %simuloidun elinkaaren perusteella. Pienet erot taulukon 3.2 tuloksiin nhden johtuvat
    %stokastisista simuloinneista seuraavaan otosvaihteluun. 
    
    %Kommentteja tai kysymyksi voi lhett osoitteeseen niku.maattanen
    %(at) etla.fi. Sen paremmin Etla kuin Niku Mttnenkn ei vastaa mahdollisista
    %virheist.
      
    %Tarvittavat tiedostot: States_both.mat, States_female.mat, States_male.mat
     
    %Kyttohje: 1. Asenna tm ohjelma sek yll mainitut tiedostot Matlabin (tai Octaven) hakupolkuun. 
    %2. Aseta parametrit riveill 27-32. 3. Aja ohjelma komennolla
    %vakuutuksen_hinta
    
    %ASETA PARAMETRIT
    sukupuoli='molemmat'; %vaihtoehtot: 'nainen', 'mies', 'molemmat';
    vuosikorvaus=12; %vuodessa maksettava korvaus (esim. tuhansia euroina)
    max_korvausika=110;% 65- korkein ik, jolloin korvaus maksetaan. Aseta >109 jos ei rajoituksia.
    min_korvausika=65;% alin ik, jolloin korvaus maksetaan. Aseta <=65, jos ei rajoituksia.
    max_korvattavat_vuodet=40; %korvattavien vuosien maksimimr. Aseta >42 jos ei rajoituksia.
    korko=0.02;%vuosikorko
    
    
    if strcmp(sukupuoli,'molemmat')
        load ('States_both.mat','States')
    elseif strcmp(sukupuoli,'nainen')
        load ('States_female.mat','States')
    elseif strcmp(sukupuoli,'mies')
        load ('States_male.mat','States')
    else
        disp('sukupuoli vrin mritelty')
        return
    end
      
    N=size(States,2);
    J=size(States,1);
      
    Korvaus=zeros(N,1);
        Laitoksessa=zeros(N,1);
        for i=1:N
            for j=1:J
                discount_rate=1/((1+korko)^(j-1));
                ika=65+(j-1);
                if States(j,i)==2
                    Laitoksessa(i)=Laitoksessa(i)+1;
                    if Laitoksessa(i)<=max_korvattavat_vuodet&&ika>=min_korvausika&&ika<=max_korvausika;
                        Korvaus(i)=Korvaus(i)+vuosikorvaus*discount_rate;
                    end
                end
            end
        end
        
   disp('aktuaarisesti reilu hinta on')
   mean(Korvaus)
      